package com.yifu.cloud.plus.v1.yifu.salary.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.yifu.cloud.plus.v1.yifu.salary.entity.SysMessageSalary;
import com.yifu.cloud.plus.v1.yifu.salary.vo.SysMessageSalaryHandelExportVo;
import com.yifu.cloud.plus.v1.yifu.salary.vo.SysMessageSalaryTemplExportVo;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 最低工资提醒-每月更新一次
 *
 * @author hgw
 * @date 2019-11-21 17:18:10
 */
public interface SysMessageSalaryService extends IService<SysMessageSalary> {

     /**
      * 最低工资提醒-每月更新一次简单分页查询
      *
      * @param sysMessageSalary 最低工资提醒-每月更新一次
      * @return
      */
     IPage<SysMessageSalary> getSysMessageSalaryPage(Page<SysMessageSalary> page, SysMessageSalary sysMessageSalary);

     IPage<SysMessageSalary> getSysMessageSalaryHandlePage(Page<SysMessageSalary> page, SysMessageSalary sysMessageSalary);

     /**
      * @param settleMonth
      * @Description: 新增-普通工资
      * @Author: hgw
      * @Date: 2019/11/21 18:10
      * @return: java.util.List<com.yifu.cloud.v1.hrms.api.vo.SysMessageSalaryVo>
      **/
     void insertSalaryBySettleMonth(@Param("settleMonth") String settleMonth);



     /**
      * @param settleMonth 结算月
      * @Description: 生成前，先删除老数据
      * @Author: hgw
      * @Date: 2019/11/21 17:28
      * @return: void
      **/
     void deleteAllBySettleMonth(String settleMonth);


     List<SysMessageSalary> getByIdExport(String[] ids);

     List<SysMessageSalary> getExport(SysMessageSalary vo);

     List<SysMessageSalaryHandelExportVo> getByIdHandleExport(String[] ids);

     List<SysMessageSalaryHandelExportVo> getHandleExport(SysMessageSalaryHandelExportVo vo);

     List<SysMessageSalaryTemplExportVo> getTempExport(String settleMonth);

     List<SysMessageSalary> getLastTHaveSalaryNosocial(String lastOneMonth, String lastTwoMonth, String lastThreeMonth);

     void createSysMessageSalaryTemp(String settleMonth);
}
