package com.yifu.cloud.plus.v1.yifu.salary.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.google.common.collect.Lists;
import com.google.common.collect.Maps;
import com.yifu.cloud.plus.v1.yifu.archives.entity.TEmployeeInfo;
import com.yifu.cloud.plus.v1.yifu.archives.vo.TSettleDomainSelectVo;
import com.yifu.cloud.plus.v1.yifu.common.core.constant.CommonConstants;
import com.yifu.cloud.plus.v1.yifu.common.core.constant.SecurityConstants;
import com.yifu.cloud.plus.v1.yifu.common.core.util.Common;
import com.yifu.cloud.plus.v1.yifu.common.core.util.R;
import com.yifu.cloud.plus.v1.yifu.common.core.vo.YifuUser;
import com.yifu.cloud.plus.v1.yifu.common.security.util.SecurityUtils;
import com.yifu.cloud.plus.v1.yifu.salary.entity.SysMessageSalary;
import com.yifu.cloud.plus.v1.yifu.salary.entity.TSalaryAccount;
import com.yifu.cloud.plus.v1.yifu.salary.mapper.SysMessageSalaryMapper;
import com.yifu.cloud.plus.v1.yifu.salary.service.SysMessageSalaryService;
import com.yifu.cloud.plus.v1.yifu.salary.service.SysMessageSalaryTempService;
import com.yifu.cloud.plus.v1.yifu.salary.service.TSalaryAccountService;
import com.yifu.cloud.plus.v1.yifu.salary.vo.SysMessageSalaryHandelExportVo;
import com.yifu.cloud.plus.v1.yifu.salary.entity.SysMessageSalaryTemp;
import com.yifu.cloud.plus.v1.yifu.salary.vo.SysMessageSalaryTemplExportVo;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 最低工资提醒-每月更新一次
 *
 * @author hgw
 * @date 2019-11-21 17:18:10
 */
@Service("sysMessageSalaryService")
public class SysMessageSalaryServiceImpl extends ServiceImpl<SysMessageSalaryMapper, SysMessageSalary> implements SysMessageSalaryService {
  /*  @Autowired
    private PreRemoteBasicArchivesService preRemoteBasicArchivesService;
    @Autowired
    private RemoteBasicArchivesService remoteBasicArchivesService;*/
    @Autowired
    private TSalaryAccountService salaryAccountService;
    @Autowired
    private SysMessageSalaryTempService sysMessageSalaryTempService;
  /*  @Autowired
    private RemoteTSettleDomainService remoteTSettleDomainService;*/


    /**
     * 最低工资提醒-每月更新一次简单分页查询
     *
     * @param sysMessageSalary 最低工资提醒-每月更新一次
     * @return
     */
    @Override
    public IPage<SysMessageSalary> getSysMessageSalaryPage(Page<SysMessageSalary> page, SysMessageSalary sysMessageSalary) {
        YifuUser user = SecurityUtils.getUser();
       /* if (!SecurityUtils.isHaveAllOrg(ServiceNameConstants.SERVICE_NAME_WXHR, user)) {
            R<List<TSettleDomainSelectVo>> remoteGetTSettleDomainVo =
                    preRemoteBasicArchivesService.getInnerSettleDomainSelectVosByExtendUser(SecurityUtils.getUser());
            if (remoteGetTSettleDomainVo == null) {
                throw new CheckedException("调用结算服务失败");
            }
            if (CommonConstants.SUCCESS != remoteGetTSettleDomainVo.getCode()) {
                throw new CheckedException("调用结算服务返回失败");
            }
            List<TSettleDomainSelectVo> remoteSettleDomainVoData = remoteGetTSettleDomainVo.getData();
            if (remoteSettleDomainVoData == null) {
                throw new CheckedException("未获取到相关结算信息");
            }
            return baseMapper.getSysMessageSalaryPage(page, sysMessageSalary, remoteSettleDomainVoData);
		} else {
		}*/
		return baseMapper.getSysMessageSalaryPage(page, sysMessageSalary, null);
	}

    @Override
    public IPage<SysMessageSalary> getSysMessageSalaryHandlePage(Page<SysMessageSalary> page, SysMessageSalary sysMessageSalary) {
        return baseMapper.getSysMessageSalaryHandlePage(page, sysMessageSalary);
    }

    /**
     * @param settleMonth
     * @Description: 新增-普通工资
     * @Author: hgw
     * @Date: 2019/11/21 18:10
     * @return: java.util.List<com.yifu.cloud.v1.hrms.api.vo.SysMessageSalaryVo>
     **/
    @Transactional
    @Override
    public void insertSalaryBySettleMonth(String settleMonth) {
        List<SysMessageSalary> sysMessageSalaries = baseMapper.insertSalaryBySettleMonth(settleMonth);
        R<List<TEmployeeInfo>> employeeInfoListR = null;//remoteBasicArchivesService.getEmployeeListForImportCheckByIds(Common.listObjectToStr(sysMessageSalaries, "employeeId", CommonConstants.COMMA_STRING), SecurityConstants.FROM_IN);
        HashMap<String, TEmployeeInfo> employeeInfoMap = Maps.newHashMap();
        List<TEmployeeInfo> employeeInfoList = employeeInfoListR.getData();
        for (TEmployeeInfo employeeInfo : employeeInfoList) {
            employeeInfoMap.put(employeeInfo.getId(), employeeInfo);
        }
        //获取单位名称
        Map<String, TSettleDomainSelectVo> settleDomainSelectVoMap=Maps.newHashMap();
        R<List<TSettleDomainSelectVo>> remoteTSettleDomainyIds = null;//remoteTSettleDomainService.getSettleDomainByIds(Common.listObjectToStrList(employeeInfoList, "settleDomain"), SecurityConstants.FROM_IN);
        if(remoteTSettleDomainyIds!=null&&remoteTSettleDomainyIds.getData()!=null){
            for (TSettleDomainSelectVo selectVo : remoteTSettleDomainyIds.getData()) {
                settleDomainSelectVoMap.put(selectVo.getId(),selectVo);
            }
        }
        for (SysMessageSalary sysMessageSalary : sysMessageSalaries) {
            //标准合同和临时人员才会提醒
            TEmployeeInfo employeeInfo = employeeInfoMap.get(sysMessageSalary.getEmployeeId());
            if (employeeInfo == null) {
                continue;
            }
            if(CommonConstants.ZERO_INT != employeeInfo.getFileStatus()){
                //非在职
                continue;
            }
            if (StringUtils.equals(CommonConstants.ONE_STRING, employeeInfo.getEmpNatrue())) {
                TSettleDomainSelectVo selectVo = settleDomainSelectVoMap.get(employeeInfo.getDeptId());
                sysMessageSalary.setCustomerId(selectVo!=null?selectVo.getCustomerId():null);
                sysMessageSalary.setCustomerName(selectVo!=null?selectVo.getCustomerName():null);
                this.save(sysMessageSalary);
            }

        }
    }


    /**
     * @param settleMonth 结算月
     * @Description: 生成前，先删除老数据
     * @Author: hgw
     * @Date: 2019/11/21 17:28
     * @return: void
     **/
    @Override
    @Transactional
    public void deleteAllBySettleMonth(String settleMonth) {
        baseMapper.deleteAllBySettleMonth(settleMonth);
    }

    @Override
    public List<SysMessageSalary> getByIdExport(String[] ids) {
        return baseMapper.getByIdExport(ids);
    }

    @Override
    public List<SysMessageSalary> getExport(SysMessageSalary vo) {
        YifuUser user = SecurityUtils.getUser();
        /*if (!SecurityUtils.isHaveAllOrg(ServiceNameConstants.SERVICE_NAME_WXHR, user)) {
            R<List<TSettleDomainSelectVo>> remoteGetTSettleDomainVo = preRemoteBasicArchivesService.getInnerSettleDomainSelectVosByExtendUser(SecurityUtils.getUser());
            if (remoteGetTSettleDomainVo == null) {
                throw new CheckedException("调用结算主体服务失败");
            }
            if (CommonConstants.SUCCESS != remoteGetTSettleDomainVo.getCode()) {
                throw new CheckedException("调用结算主体返回失败");
            }
            List<TSettleDomainSelectVo> remoteSettleDomainVoData = remoteGetTSettleDomainVo.getData();
            return baseMapper.getExport(vo, remoteSettleDomainVoData);
        } else {
        }*/
		return baseMapper.getExport(vo, null);
	}

    @Override
    public List<SysMessageSalaryTemplExportVo> getTempExport(String settleMonth) {
        return baseMapper.getTempExport(settleMonth);
    }

    @Override
    public List<SysMessageSalaryHandelExportVo> getByIdHandleExport(String[] ids) {
        return baseMapper.getByIdHandleExport(ids);
    }

    @Override
    public List<SysMessageSalaryHandelExportVo> getHandleExport(SysMessageSalaryHandelExportVo vo) {
        return baseMapper.getHandleExport(vo);
    }


    @Override
    public List<SysMessageSalary> getLastTHaveSalaryNosocial(String lastOneMonth, String lastTwoMonth, String lastThreeMonth) {
        return baseMapper.getLastTHaveSalaryNosocial(lastOneMonth, lastTwoMonth, lastThreeMonth);
    }

    @Override
    public void createSysMessageSalaryTemp(String month) {
        //删除之前的数据
        sysMessageSalaryTempService.remove(Wrappers.<SysMessageSalaryTemp>query().lambda().eq(SysMessageSalaryTemp::getSettleMonth, month));
        //获取当月的所有最低工资，并且是临时人员
        // 获取他上次发工资是不是在最低工资表里面 次数+1
        //继续循环上次，如果发现上次没有在最低工资表里面，则循环下一个人员
        List<SysMessageSalary> list = this.list(Wrappers.<SysMessageSalary>query().lambda().eq(SysMessageSalary::getSettleMonth, month));
        R<List<TEmployeeInfo>> employeeInfoListR = null;//remoteBasicArchivesService.getEmployeeListForImportCheckByIds(Common.listObjectToStr(list, "employeeId", CommonConstants.COMMA_STRING), SecurityConstants.FROM_IN);
        HashMap<String, TEmployeeInfo> employeeInfoMap = Maps.newHashMap();
        List<TEmployeeInfo> employeeInfoList = employeeInfoListR.getData();
        for (TEmployeeInfo employeeInfo : employeeInfoList) {
            employeeInfoMap.put(employeeInfo.getId(), employeeInfo);
        }
        //获取当月的所有最低工资，并且是临时人员
        List<SysMessageSalary> tempSysMessageSalary = Lists.newArrayList();
        for (SysMessageSalary salary : list) {
            TEmployeeInfo employeeInfo = employeeInfoMap.get(salary.getEmployeeId());
			tempSysMessageSalary.add(salary);
        }
        for (SysMessageSalary messageSalary : tempSysMessageSalary) {
            //获取他上次发工资是不是在最低工资表里面 次数+1
            List<TSalaryAccount> accountList = salaryAccountService.list(Wrappers.<TSalaryAccount>query().lambda().eq(TSalaryAccount::getEmpIdcard, messageSalary.getEmployeeIdnum())
                    .lt(TSalaryAccount::getSalaryGiveTime, messageSalary.getSalaryMonth()).groupBy(TSalaryAccount::getSalaryGiveTime).orderByDesc(TSalaryAccount::getSalaryGiveTime));
            int lowerConut = 1;
            for (TSalaryAccount salaryAccount : accountList) {
                long count = this.count(Wrappers.<SysMessageSalary>query().lambda().eq(SysMessageSalary::getEmployeeId, salaryAccount.getEmpId()).eq(SysMessageSalary::getSalaryMonth, salaryAccount.getSalaryGiveTime()));
                if (count > 0) {
                    //如果大于0 则上次也是最低工资。
                    lowerConut++;
                } else {
                    break;
                }
            }
            //判断最低次数
            if (lowerConut > 1) {
                SysMessageSalaryTemp messageSalaryTemp = new SysMessageSalaryTemp();
                messageSalaryTemp.setRelateId(messageSalary.getId());
                messageSalaryTemp.setTimes(lowerConut);
                messageSalaryTemp.setSettleMonth(month);
                sysMessageSalaryTempService.save(messageSalaryTemp);
            }

        }


    }
}
